image: cypress/base:16.5.0

stages:
  - build
  - dev
  - qa
  - qa prod
  - deploy
  - prod

variables:
  npm_config_cache: "$CI_PROJECT_DIR/.npm"
  CYPRESS_CACHE_FOLDER: "$CI_PROJECT_DIR/cache/Cypress"

cache:
  key: ${CI_COMMIT_REF_SLUG}
  paths:
    - .cache/*
    - cache/Cypress
    - node_modules
    - build

build job:
  stage: build
  script:
    - echo 'This is the build stage'
    - npm install

dev test job:
  stage: dev
  script:
    - echo 'This is the dev test stage'
    - npm run test:dev

qa test job:
  stage: qa
  script:
    - echo 'This is the qa test stage'
    - npm run test:qa

qa-prod test job:
  stage: qa prod
  script:
    - echo 'This is the qa-prod test stage'
    - npm run test:qa-prod

deploy job:
  stage: deploy
  when: manual
  script:
    - echo 'This is the deploy job'

production:
  stage: prod
  when: manual
  script:
    - echo 'This is the production job'
